#include "menu.h"
#include "init.h"
#include "gamelogic.h"
#include "vars.h"
#include "draw.h"
#include "moves.h"
#include "input.h"
#include "hscore.h"
#include "draw.h"
#include "sounds.h"
#include "sfx.h"

int play_the_menu(TPONG_MENU *menu, int game_state_type, int cur_selec) {
   game_state = game_state_type;
	//cur_selection = cur_selec;
   //on vient d'appuyer sur une touche pour lancer le menu
   key_pressed = TRUE;
   game_time = 0;//on remet  zro, sinon, on risque d'avoir des problmes! :)
   //on est pret  jouer maintenant
   while (key[KEY_ESC] == FALSE || key_pressed == TRUE) {

      while (game_time > 0) { //en temps rel le menu, siouplait!

         //on commence par grer les entres(clavier, joy, ...)
         //on le met  l'intrieur de la boucle au cas ou l'ordi soit une larve
         
         gere_input_menu(menu);
         
         if (key[KEY_ENTER] && key_pressed == FALSE) {//il appuie sur Enter?
            play_sound(data_sfx[MENU_OK_WAV].dat, SCREEN_W/2);    
            return menu->cur_selection;
         }
         
         --game_time;//dcrmente notre compteur "temps-rel"
      }

      draw_menu(menu);

   }

   return -1;
}


int play_the_game(void) {//la boucle infinie du jeu
   int last_sec_counter = 0;
   current_score = 0; //On remet le score  zro
   
   game_time = 0;//on remet le compteur du temps rel  0
   //on est pret  jouer maintenant
   while (!key[KEY_ESC]) {

      //on update les positions de tout le monde
      while (game_time > 0) {
         //on commence par gre les entres(clavier, joy, ...)
         //on le met  l'intrieur de la boucle au cas ou l'ordi soit une larve

         gere_input();

         update_game_logic();
         --game_time;
      }
      //on update les fps:

      if (current_sec_counter != last_sec_counter) {
         fps = current_fps;
         last_sec_counter = current_sec_counter;
         current_fps = 0;
      }

      current_fps++;
      draw();//on dssine
   }
   /* Avant de quitter le jeu actuel, on affiche les rsultats des parties dans le logfile */
   if (game_type == DUEL_2P || game_type == DUEL_2AI)
      fprintf(fp, " Left scored : %ld\nRight scored : %ld\n", game_info.nb_left_wins, game_info.nb_right_wins);
   
   
   
   return RETURN_MAIN_MENU;//on quitte compltement
}

void update_game_logic(void) {
   int i;
 
   //on s'occupe de bouger les balles
   
   for (i = 0; i < nb_max_balls; ++i) {
      if (ball[i]->EXIST == TRUE) 
         move_ball(ball[i]);
   }

   //on bouge les raquettes
   for (i = 0; i < nb_max_players; ++i) {//On fait comme si il n'y avait que deux joueurs
      move_racket(player[i]->racket);
   }
   
   //Si il n'y a plus aucune balle!
   if (nb_current_balls <= 0) {

      //on update le score
      game_info.last_score = current_score;

      if (game_type == DUEL && (game_info.new_hiscore_pos = check_scores(cur_level->high_score_entry, SIZE_HIGH_SCORE_TABLE, game_info.last_score)) != -1) {

         /* On change de section! */
         game_state = ASKING_PLAYER_NAME;

         //J'ai repris le systme de hiscore d'un autre jeu ( moi...)
         //Je l'ai un peu adapt.
         //Tout d'abord, on update le score mais on laisse un nom vide
         update_scores(cur_level->high_score_entry, SIZE_HIGH_SCORE_TABLE, "", game_info.last_score);

         //Ensuite, on s'occupe de demander le nom du joueur
         name = malloc((MAX_NAME_LENGTH+1)*sizeof(char));         
         get_player_name(name, game_info.last_score);

         //enfin, on "update" le nom dans le tableau!         
         change_score_name(cur_level->high_score_entry, name, game_info.new_hiscore_pos);
         free(name);
         
         packfile_password("temp");
         //au sauvegarde le fichier final, au cas ou il y ait un problme par la suite:
         save_scores(cur_level->high_score_entry, cur_level->score_file_name);

         packfile_password(NULL);
         
         /* On retourne au Jeu! */
         game_state = PLAYING_THE_GAME;
      }
      
      
      //ON RECOMMENCE A JOUER TOUT DE SUITE
      //cas spcial pour la numro 0!
      init_new_ball(ball[0]);
      nb_current_balls = 1;
      
      /* Pour le mode duel uniquement, le reste, on s'en fou! */
//      if (game_type == DUEL)
  //       ++(game_info.nb_games);
      game_time = 0;
      current_score = 0;      
   }

   return;
}